/********************************************************************************
 * Copyright (C) 2021 Jon Radchenko and others.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * This Source Code may also be made available under the following Secondary
 * Licenses when the conditions for such availability set forth in the Eclipse
 * Public License v. 2.0 are satisfied: GNU General Public License, version 2
 * with the GNU Classpath Exception which is available at
 * https://www.gnu.org/software/classpath/license.html.
 *
 * SPDX-License-Identifier: EPL-2.0 OR GPL-2.0 WITH Classpath-exception-2.0
 ********************************************************************************/
import "../../styles/server-proxy-list.css";
import * as React from 'react';
import { ReactWidget } from '@theia/core/lib/browser';
import { ServerProxyInstanceManager } from 'theia-server-proxy-extension/lib/browser/server-proxy-instance-manager';
import { ServerProxyInstance } from 'theia-server-proxy-extension/lib/browser/server-proxy-instance';
import { ServerProxyOpenHandler } from 'theia-server-proxy-extension/lib/browser/server-proxy-open-handler';
import { WindowService } from "@theia/core/lib/browser/window/window-service";
import { ServerProxyUrlManager } from "theia-server-proxy-extension/lib/common/server-proxy-url-manager";
export declare class ServerProxyListWidget extends ReactWidget {
    static readonly ID: string;
    static readonly LABEL = "Server Proxy List";
    protected readonly serverProxyInstanceManager: ServerProxyInstanceManager;
    protected readonly windowService: WindowService;
    protected readonly serverProxyOpenHandler: ServerProxyOpenHandler;
    protected readonly serverProxyUrlManager: ServerProxyUrlManager;
    protected serverProxyInstances: ServerProxyInstance[];
    protected init(): Promise<void>;
    protected onOpen(instance: ServerProxyInstance): Promise<void>;
    protected render(): React.ReactNode;
}
export interface ServerProxyComponentProps {
    onOpenBrowser: () => void;
    onStop: () => Promise<Boolean>;
    onOpen: () => Promise<void>;
    instance: ServerProxyInstance;
}
//# sourceMappingURL=server-proxy-list-widget.d.ts.map