"use strict";
/********************************************************************************
 * Copyright (C) 2021 Jon Radchenko and others.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * This Source Code may also be made available under the following Secondary
 * Licenses when the conditions for such availability set forth in the Eclipse
 * Public License v. 2.0 are satisfied: GNU General Public License, version 2
 * with the GNU Classpath Exception which is available at
 * https://www.gnu.org/software/classpath/license.html.
 *
 * SPDX-License-Identifier: EPL-2.0 OR GPL-2.0 WITH Classpath-exception-2.0
 ********************************************************************************/
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServerProxyListWidget = void 0;
require("../../styles/server-proxy-list.css");
var React = require("react");
var inversify_1 = require("inversify");
var browser_1 = require("@theia/core/lib/browser");
var server_proxy_instance_manager_1 = require("theia-server-proxy-extension/lib/browser/server-proxy-instance-manager");
var server_proxy_open_handler_1 = require("theia-server-proxy-extension/lib/browser/server-proxy-open-handler");
var window_service_1 = require("@theia/core/lib/browser/window/window-service");
var server_proxy_1 = require("theia-server-proxy-extension/lib/common/server-proxy");
var server_proxy_url_manager_1 = require("theia-server-proxy-extension/lib/common/server-proxy-url-manager");
var ServerProxyListWidget = /** @class */ (function (_super) {
    __extends(ServerProxyListWidget, _super);
    function ServerProxyListWidget() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.serverProxyInstances = [];
        return _this;
    }
    ServerProxyListWidget_1 = ServerProxyListWidget;
    ServerProxyListWidget.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.id = ServerProxyListWidget_1.ID;
                        this.title.label = ServerProxyListWidget_1.LABEL;
                        this.title.caption = ServerProxyListWidget_1.LABEL;
                        this.title.closable = true;
                        _a = this;
                        return [4 /*yield*/, this.serverProxyInstanceManager.getInstances()];
                    case 1:
                        _a.serverProxyInstances = _b.sent();
                        this.update();
                        this.toDispose.push(this.serverProxyInstanceManager.updated(function () { return __awaiter(_this, void 0, void 0, function () {
                            var _a;
                            return __generator(this, function (_b) {
                                switch (_b.label) {
                                    case 0:
                                        _a = this;
                                        return [4 /*yield*/, this.serverProxyInstanceManager.getInstances()];
                                    case 1:
                                        _a.serverProxyInstances = _b.sent();
                                        this.update();
                                        return [2 /*return*/];
                                }
                            });
                        }); }));
                        return [2 /*return*/];
                }
            });
        });
    };
    ServerProxyListWidget.prototype.onOpen = function (instance) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.serverProxyOpenHandler.openInstance(instance)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    ServerProxyListWidget.prototype.render = function () {
        var _this = this;
        return (React.createElement("div", { className: "server-proxy-list" }, this.serverProxyInstances.map(function (instance) {
            return React.createElement(ServerProxyComponent, __assign({ key: instance.id }, {
                instance: instance,
                onStop: function () { return instance.stop(); },
                onOpen: function () { return _this.onOpen(instance); },
                onOpenBrowser: function () { return _this.windowService.openNewWindow(_this.serverProxyUrlManager.getPublicPath(instance.serverProxy, instance.id), { external: true }); }
            }));
        })));
    };
    var ServerProxyListWidget_1;
    ServerProxyListWidget.ID = "server.proxy.debug.widget";
    ServerProxyListWidget.LABEL = 'Server Proxy List';
    __decorate([
        inversify_1.inject(server_proxy_instance_manager_1.ServerProxyInstanceManager),
        __metadata("design:type", server_proxy_instance_manager_1.ServerProxyInstanceManager)
    ], ServerProxyListWidget.prototype, "serverProxyInstanceManager", void 0);
    __decorate([
        inversify_1.inject(window_service_1.WindowService),
        __metadata("design:type", Object)
    ], ServerProxyListWidget.prototype, "windowService", void 0);
    __decorate([
        inversify_1.inject(server_proxy_open_handler_1.ServerProxyOpenHandler),
        __metadata("design:type", server_proxy_open_handler_1.ServerProxyOpenHandler)
    ], ServerProxyListWidget.prototype, "serverProxyOpenHandler", void 0);
    __decorate([
        inversify_1.inject(server_proxy_url_manager_1.ServerProxyUrlManager),
        __metadata("design:type", server_proxy_url_manager_1.ServerProxyUrlManager)
    ], ServerProxyListWidget.prototype, "serverProxyUrlManager", void 0);
    __decorate([
        inversify_1.postConstruct(),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", Promise)
    ], ServerProxyListWidget.prototype, "init", null);
    ServerProxyListWidget = ServerProxyListWidget_1 = __decorate([
        inversify_1.injectable()
    ], ServerProxyListWidget);
    return ServerProxyListWidget;
}(browser_1.ReactWidget));
exports.ServerProxyListWidget = ServerProxyListWidget;
var ServerProxyComponent = /** @class */ (function (_super) {
    __extends(ServerProxyComponent, _super);
    function ServerProxyComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ServerProxyComponent.prototype.getStatusClassName = function () {
        if (server_proxy_1.ServerProxyInstanceStatus.isRunning(this.props.instance.status)) {
            return "status-started";
        }
        else if (server_proxy_1.ServerProxyInstanceStatus.isCompleted(this.props.instance.status)) {
            return "status-stopped";
        }
        else {
            return "status-loading";
        }
    };
    ServerProxyComponent.prototype.render = function () {
        var instance = this.props.instance;
        var actions = [];
        actions.push(React.createElement("button", { className: "theia-button", key: "stop", onClick: this.props.onStop }, "Stop"));
        actions.push(React.createElement("button", { className: "theia-button", key: "open", onClick: this.props.onOpen }, "Open"));
        actions.push(React.createElement("button", { className: "theia-button", key: "open-browser", onClick: this.props.onOpenBrowser }, "Open in Browser"));
        var statusClassName = this.getStatusClassName();
        return React.createElement("div", { className: "row exposedPort", id: "port-" + instance.id, title: JSON.stringify(instance.context) },
            React.createElement("span", { className: "indicator" },
                React.createElement("i", { className: "fa " + statusClassName })),
            React.createElement("span", { className: "name" }, instance.serverProxy.name),
            React.createElement("span", { className: "name" },
                " \u2013 ",
                instance.status.statusId),
            React.createElement("span", { className: "actions" }, actions));
    };
    return ServerProxyComponent;
}(React.Component));
//# sourceMappingURL=server-proxy-list-widget.js.map